package bitel.billing.test.convert;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.Reader;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bitel.billing.common.CommonUtils;
import bitel.billing.common.TimeUtils;
import bitel.billing.server.ServerEventProcessor;
import bitel.billing.server.admin.bean.AddressUtils;
import bitel.billing.server.admin.resource.bean.NumberResourceUseManager;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.phone.bean.ClientItem;
import bitel.billing.server.phone.bean.ClientItemManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.SetupData;
import bitel.billing.server.util.Utils;
import bsh.StringUtil;

public class ASVTNN
{
	private static SetupData bgSetup = null;
	
	private static int GROUP_ID = 1;
	private static int PHYS_PATTERN = 2;
	private static int JUR_PATTERN = 1;
	private static int FIO_PID = 1;						
	//private static int ADDRESS_RAW_PID = 1;
	private static int CITY_ID = 1;
	private static int ADDRESS_PID = 1;
	private static int SOURCE_ID = 1;
	private static int MODULE_ID = 1;
	
	private static int ORG_NAME_PID = 1;
	private static int ADDRESS_PHYS_PID  = 1;
	private static int ADDRESS_JUR_PID = 1;
	private static int INN_PID = 1;
	private static int KPP_PID = 1;
	private static int BIK_PID = 1;
	private static int BANK_NAME = 1;
	private static int ORG_ACCOUNT_PID = 1;
	private static int COMMENT_PID = 1;
	private static int ORG_TYPE_PID = 1;
	private static int OWNER_TYPE_PID = 1;
	

	
	private static Map<String, Integer > billingTarifMap = new HashMap<String, Integer>();
	private static Map<String, Integer > streetMap = new  HashMap<String, Integer > ();
	private static Map<Integer, Map<String, Integer> >  houseMap = new HashMap<Integer, Map<String, Integer> >();
	
	private static Map< Integer, Map > listMap  = new HashMap< Integer, Map > ();
	
	
	//603093 .  . .165/4 .65
	private static String templatePhys = "^(\\d+) \\.(.+) (|-)\\.(.+) .(\\d+)(/(.+))? \\.(.+)$";										
	private static Pattern patternPhys = Pattern.compile( templatePhys );
	
	private static String templateJur = "^(\\d+) \\.(.+) (|-)\\.(.+) .(\\d+)(.+)?$";										
	private static Pattern patternJur = Pattern.compile( templateJur );
	
	
	private static Calendar contractDate = TimeUtils.parseCalendar ( "01.12.2008", "dd.MM.yyyy" );
	
	// - 
	public static Map<String, Map<String, String> >  loadCustomers( String filePath) throws IOException
	{
		Map<String, Map<String, String> > result = new HashMap<String, Map<String, String>>();
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "cp1251" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			Map map = new HashMap();
			int idx = 0;
			String account =  line [idx++];		
			map.put( "name",  line [idx++]  );
			map.put( "address",  line [idx++] );						
			map.put( "dateAccount",  line [idx++]  );
			map.put( "name1",  line [idx++]  );
			map.put( "contract_num",  line [idx++]  );
			map.put( "contract_date",  line [idx++]  );
			map.put( "comment",  line [idx++]  );			
			result.put( account, map );			
			
		}
		
		return result;
	}
	
	
	
	//      
	public static void  loadTarifs(Map<String, Map<String, String> > customers, Map<String, String> tariffMap) throws IOException
	{
		Map<String, Map<String, String> > result = new HashMap<String, Map<String, String>>();
		
				
		
		for ( Map.Entry  entry : tariffMap.entrySet() )
		{
			int idx = 0;
			String account =  (String) entry.getKey();	
			String tariff = (String) entry.getValue();
						
			Map customerMap = customers.get( account );
			if ( customerMap == null)
			{
				System.out.println("account " + account + " is not exist" );
			}
			else
			{
				customerMap.put( "tariff",  tariff );
			}
		}
		
		
	}
	
	// - 
	public static Map<String, Map<String, String> >  loadFirms( String filePath) throws IOException
	{
		Map<String, Map<String, String> > result = new HashMap<String, Map<String, String>>();
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "cp1251" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			Map map = new HashMap();
			int idx = 0;
			String account =  line [idx++];			
			map.put( "name", line [idx++] );
			map.put( "address_phys",  line [idx++] );
			map.put( "address_jur",  line [idx++] );
			map.put( "inn",  line [idx++]  );
			map.put( "kpp",  line [idx++]  );
			map.put( "bik",  line [idx++]  );			
			map.put( "bank",  line [idx++]  );
			map.put( "account2",  line [idx++]  );
			map.put( "account_date",  line [idx++]  );
			map.put( "name2",  line [idx++]  );			
			map.put( "contract_num",  line [idx++]  );
			map.put( "contract_date",  line [idx++]  );
			map.put( "comment",  line [idx++]  );			
			map.put( "decode",  line [idx++]  );
			result.put( account, map );			
			
		}
		
		return result;
	}	
	
	//-  
	public static Map<String, Map<String, String> >  loadOrgType( String filePath) throws IOException
	{
		Map<String, Map<String, String> > result = new HashMap<String, Map<String, String>>();
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "cp1251" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			Map map = new HashMap();
			int idx = 0;
			String account =  line [idx++];
			map.put( "org_name",  line [idx++] );
			map.put( "org_F_ORG_NAME",  line [idx++]  );				
			result.put( account, map );						
		}
		
		return result;
	}	
	
	//  
	public static Map<String, Map<String, String> >  loadOwnerType( String filePath) throws IOException
	{
		Map<String, Map<String, String> > result = new HashMap<String, Map<String, String>>();
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "cp1251" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			Map map = new HashMap();
			int idx = 0;
			String account =  line [idx++];
			map.put( "owner_name",  line [idx++] );
			map.put( "owner_F_S_NAME",  line [idx++]  );				
			result.put( account, map );						
		}
		
		return result;
	}		
	
	//   
	public static List< Map<String, String> >  loadPhones( String filePath, Map<String, String> tariffMap) throws IOException
	{
		List< Map<String, String> > result = new ArrayList<Map<String, String>>();
		
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "cp1251" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		//    ..   . 
		Map<String, Map> hash = new HashMap() ;
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			
			int idx = 0;
			String account =  line [idx++];
			String phoneName =  line [idx++];
			String number =  line [idx++];
			if ( CommonUtils.isEmptyString( number))
			{
				continue;
			}
			String phone_tariff = line [idx++];
			String key = account + "##" + number;
			
			
			Map map = hash.get( key );
			if ( map == null)
			{
				map = new HashMap();
				hash.put( key, map );
				result.add( map );
			}
			
			map.put( "account",  account );
			map.put( "phone_name",  phoneName );
			map.put( "phone_number",  number  );
			
			
			//,    
			if ( CommonUtils.isEmptyString(tariffMap.get( account ) ) && !CommonUtils.isEmptyString( phone_tariff ) )
			{
				tariffMap.put( account,  phone_tariff  );
			}
			map.put( "phone_name2",  line [idx++]  );
			map.put( "phone_service_kode",  line [idx++]  );
			map.put( "phone_service_name",  line [idx++]  );
			map.put( "phone_address",  line [idx++]  );			
						
			
		}
		
		return result;
	}
	
	//  :   - cid
	private static Map<String, Integer> createContracts( Map<String, Map<String, String> >  users, boolean isJur)
	{		
		Map<String, Integer> result = new HashMap<String, Integer>();
		Connection con = null;
		
		
		billingTarifMap = ConvertUtil.getBillingTariffMap( bgSetup );		
		streetMap = ConvertUtil.getBillingStreetMap ( bgSetup );
		houseMap = ConvertUtil.geHouseMap( bgSetup ); 		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			ContractManager manager =  new ContractManager( con );
			
			System.out.println( users.size() + " contracts was found..");		
			
			int idx = 0;
			for ( Map.Entry<String, Map<String, String>> entry : users.entrySet())
			{				
	    		int pattern = isJur ? JUR_PATTERN : PHYS_PATTERN;
	    		String account = entry.getKey();
	    		Map map = entry.getValue(); 
	    		
	    		Contract contract = null;
	    			    		
	    		contract = manager.createFromPattern( pattern, account,  contractDate, "");
	    		
	    		
	    		if (contract != null)
	    		{	
	    			int cid = contract.getID();
	    			
	    			result.put( account, cid );
	    				
					updateContactInfo( cid, map );
					updateContactParams( cid, map, isJur );
					
					if ( isJur )
					{
						
						updateAddress(cid, account, map, streetMap, houseMap,(String) map.get( "address_jur" ), ADDRESS_JUR_PID, isJur );
						updateAddress(cid, account, map, streetMap, houseMap,(String) map.get( "address_phys" ), ADDRESS_PHYS_PID, isJur );
					}
					else
					{
						String address =  (String) map.get( "address" );
						updateAddress(cid, account, map, streetMap, houseMap,(String) map.get( "address" ), ADDRESS_PID, isJur );
					}
					
					updateTarifs( cid, account, map, billingTarifMap );
					
															
	    		}
	    		        		
	    	}			
			
			System.out.println( users.size() + " contracts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
		return result;
		
	}		
		
	private static void updateContactInfo( int cid, Map<String, String> map)
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,  " +						
						" comment = ? " +
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP_ID );			
			ps.setString( idx++, map.get( "name" ) );
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
	}	
	
	private static void updateContactParams(	int cid, Map<String, String> map, boolean isJur)
	{
		Connection con = null;
		try
		{
			con = bgSetup.getDBConnectionFromPool();			
			if ( isJur )
			{
				ConvertUtil.addContactParamString( cid, con, map.get( "name" ), ORG_NAME_PID );
				//ConvertUtil.addContactParamString( cid, con, map.get( "address_phys" ), ADDRESS_PHYS_PID );
				//ConvertUtil.addContactParamString( cid, con, map.get( "address_jur" ), ADDRESS_JUR_PID );
				ConvertUtil.addContactParamString( cid, con, map.get( "inn" ), INN_PID );
				ConvertUtil.addContactParamString( cid, con, map.get( "kpp" ), KPP_PID );
				ConvertUtil.addContactParamString( cid, con, map.get( "bik" ), BIK_PID );
				ConvertUtil.addContactParamString( cid, con, map.get( "bank" ), BANK_NAME );
				ConvertUtil.addContactParamString( cid, con, map.get( "account2" ), ORG_ACCOUNT_PID );
				ConvertUtil.addContactParamString( cid, con, map.get( "comment" ), COMMENT_PID );
				
				
				updateListParam( cid, con, map.get( "org_F_ORG_NAME" ), ORG_TYPE_PID  );
				updateListParam( cid, con, map.get( "owner_F_S_NAME" ),  OWNER_TYPE_PID );
								
			}
			else
			{
				ConvertUtil.addContactParamString( cid, con, map.get( "name" ), FIO_PID );						
				//ConvertUtil.addContactParamString( cid, con, map.get( "address" ), ADDRESS_RAW_PID );	
				ConvertUtil.addContactParamString( cid, con, map.get( "comment" ), COMMENT_PID );
			}			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}	
		
	}	
	
	private static void updateAddress(	int cid,
	                                  	String account,
	                                 	Map<String, String> map,
	                                 	Map<String, Integer > streetMap,
	                                 	Map<Integer, Map<String, Integer> >  houseMap,
	                                 	String address,
	                                 	int pid, 
	                                 	boolean isJur)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			
			address = address.trim();
			
			if ( CommonUtils.isEmptyString(  address ) || address.equals( ", -" ))
			{
				return;
			}
			
			//-, 267-51
		
			
			String index = "";
			String city = "";
			String street = "";
			String house = "";
			String frac = "";
			String flat = "";
			
			
			Integer streetId = -1;			
			
			Matcher m = null;
		

			boolean flag = false;
			if ( !isJur)
			{
				if( (m = patternPhys.matcher( address )).find() )
				{
					index = m.group( 1 );
					city = m.group(2);				
					street =   m.group( 4 );
					house = m.group( 5 );
					frac = m.group( 7 );
					flat = m.group( 8 );
					flag = true;
				}
			}
			else
			{
				if( (m = patternJur.matcher( address )).find() )
				{
					index = m.group( 1 );
					city = m.group(2);				
					street =   m.group( 4 );
					house = m.group( 5 );					
					flat = m.group( 6 );
					flag = true;
				}				
				
			}
			
			if ( !flag ) 
			{
				
				System.out.println( " Unknown address format(" + account +"):"  + address); 		
				return;
			
			}
			if (CommonUtils.isEmptyString( street ) ||  CommonUtils.isEmptyString( house ) )
			{
				System.out.println( " Unknown address format(" + account +"):"  + address);
				return;
			}
			
			if ( flat == null )
			{
				flat = "";
			}
			
			
			streetId = streetMap.get( street );
			
			if ( streetId == null)
			{			
				String query = "INSERT into address_street( title, cityId) VALUES(?, ?) ";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setString( 1, street );								
				ps.setInt( 2, CITY_ID );
				ps.executeUpdate();
				streetId = ConvertUtil.lastInsertId( con );
				streetMap.put( street, streetId );
			}
			
			Map<String, Integer> houses = houseMap.get( streetId ); 
			if ( houses == null )
			{
				houses = new HashMap<String, Integer>();
				
				houseMap.put( streetId, houses );
			}
			String key = ConvertUtil.getHouseKey( Integer.valueOf( house), frac );
			if ( houses.get( key ) == null )
			{
				
				String query = "INSERT INTO address_house " + "( cityid,  areaid, quarterid, streetid,"
				   + " house, frac, box_index, amount, comment, dt) " + "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setInt( 1, CITY_ID );
				ps.setInt( 2, 0 );
				ps.setInt( 3, 0 );
				ps.setInt( 4, streetId );
				ps.setInt( 5, Integer.valueOf( house) );
				ps.setString( 6, frac );
				ps.setString( 7, "" );
				ps.setInt( 8, 0 );
				ps.setString( 9, "" );
				ps.setDate( 10, TimeUtils.convertDateToSQL( new  Date() ) );
				ps.executeUpdate();		
				int houseId = ConvertUtil.lastInsertId( con );
				houses.put( key, houseId );
			}
			
			int houseId =  houses.get( key );
			
			
			
			
			String addressFull = AddressUtils.getAddress( bgSetup, index, city, "", "", street, house, frac, "", "", "", "", ""  ); 
			
			String query = "INSERT INTO contract_parameter_type_2 " +
			"( cid, pid, hid, flat,  pod, floor, address, comment, room) " +
			"VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ? )";
			PreparedStatement ps =  con.prepareStatement(   query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.setInt( 3, houseId );
			ps.setString( 4, flat );
			ps.setInt( 5, -1 );
			ps.setInt( 6, -1 );
			ps.setString( 7, addressFull );
			ps.setString( 8, "" );
			ps.setString( 9, "" );
			ps.executeUpdate();		   
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
		
	}	
	
	private static void updateTarifs(	int cid,
	                                 	String account,
	                                 	Map<String, String> map,
	                                 	Map<String, Integer > billingTarifMap)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
		    
		    String tarifName = map.get( "tariff" );
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	return;
		    }
		    		
		    tarifName = tarifName.trim(); 
		    tarifName = tarifName.toLowerCase();
		    
		    if ( CommonUtils.isEmptyString( tarifName ) )
		    {
		    	//System.out.println("error: tarif is empty for user " + number);
		    	return;
		    }
		    		    
		    
		    Integer tpid = billingTarifMap.get( tarifName );
		    
	    	if ( tpid == null)
	    	{	
	    		tpid = ConvertUtil.addNewTariff( con,  tarifName);
	    		System.out.println("New Tariff was added:" + tarifName);
	    		billingTarifMap.put( tarifName, tpid );
	    	}
	        
	    	String query = "INSERT INTO contract_tariff( cid, tpid) VALUES ( ?, ?)";
		    PreparedStatement ps =  con.prepareStatement(   query );
		    
		    ps.setInt( 1, cid );			    
    		ps.setInt( 2, tpid );
    		ps.executeUpdate();	    	
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
	}	
		
	private static void createPoints(	List<Map<String, String>> numbers, Map<String, Integer> contractMap )
	{
		Connection con = null;
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			int pc = 0;
			
			for ( Map <String, String> map : numbers )
			{
				String account =  map.get( "account" );
				 
				
				ClientItem item = new ClientItem();

				
			
				Integer cid = contractMap.get( account );
				String number = map.get( "phone_number" );
				
				if ( CommonUtils.isEmptyString( number ))
				{
					continue;
				}

				number = "7" + number ;

				
				pc++;
				item.setContractId( cid );
				item.setSourceId( SOURCE_ID );

				item.setDate1( contractDate );

				item.setType( ClientItem.TYPE_POINT );

				item.setClientNumbers( Utils.stringToList( number ) );
				item.setClientPorts( new ArrayList<String>() );
				
				item.setComment( "   " );
				item.setAlias( "" );
				 
				ClientItemManager man = new ClientItemManager( con,
						MODULE_ID );
				NumberResourceUseManager resourceUseManager = new NumberResourceUseManager( con,
						MODULE_ID );

				try
				{
					man.addClientItem( item );
				}
				catch( Exception e )
				{
					e.printStackTrace();
					throw new RuntimeException("Error while creating point " + number);
				}
				
				//   
			}
			
			System.out.println( pc + " phones was added" );
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			throw new RuntimeException("Error while creating points");
		}

		finally
		{
			bgSetup.returnConToPool( con );
		}

	}	
	
	private static  void updateListParam(int cid, Connection con, String value, int pid   ) throws SQLException
	{
		
		if ( CommonUtils.isEmptyString( value ) || CommonUtils.isBlankString( ( value ) ) )
		{
			return;
		}
		
		Map map = listMap.get( pid ); 
		if ( map == null)
		{
			map = new HashMap();
			listMap.put ( pid, map);
		}
		
		
		Integer id  = (Integer) map.get( value );
		
		if ( id == null )
		{
			String query = null;
			PreparedStatement ps = null;
	
			
			query = "INSERT INTO contract_parameter_type_7_values ( pid, title ) VALUES (?, ?)";
			ps = con.prepareStatement( query );
			ps.setInt( 1, pid );
			ps.setString( 2, value );
	
			ps.executeUpdate();
			ps.close();
			
			id = Utils.lastInsertId( con );
			map.put( value, id );
		}
		
		
		ConvertUtil.addContrtactParamList( cid, con, id, pid );
		
	}	
	
	private static void buildListMap ()
	{		
		listMap.put( ORG_TYPE_PID, buildListMap ( ORG_TYPE_PID ) );			
		listMap.put( OWNER_TYPE_PID, buildListMap ( OWNER_TYPE_PID ) );		
	}	
	
	private static Map buildListMap ( int pid )
	{
		
		Map result = new HashMap ();
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			String query = "SELECT id, title FROM contract_parameter_type_7_values WHERE pid=? ORDER BY title";
            PreparedStatement ps = con.prepareStatement( query );
            ps.setInt( 1, pid );
            ResultSet rs = ps.executeQuery();
            while ( rs.next() )
            {
            	result.put( rs.getString("title"), rs.getInt( "id" ) );
            }
            ps.close();			
		}
		catch( Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}
		
		return result;
	}
		
	/**
	 * @param args
	 */
	public static void main( String[] args )
	{
		try
		{
			bgSetup = new SetupData( "data.data" );

			//     ,     
			EventProcessor.initProcessor( bgSetup, true, new ServerEventProcessor() );      

			FileSetup settings = new FileSetup( "convert_asvt" );
			
			GROUP_ID = settings.getIntValue( "group", -1 );
			PHYS_PATTERN = settings.getIntValue( "template.phis", -1 );
			JUR_PATTERN = settings.getIntValue( "template.jur", -1 );
			CITY_ID = settings.getIntValue( "city.id", -1 );
			SOURCE_ID = settings.getIntValue( "source.id", -1 );
			MODULE_ID = settings.getIntValue( "mid.phone", -1 );

			FIO_PID = settings.getIntValue( "pid.fio", -1 );;
			ADDRESS_PID = settings.getIntValue( "pid.address", -1 );
			//ADDRESS_RAW_PID = settings.getIntValue( "pid.address.raw", -1 );
			ORG_NAME_PID = settings.getIntValue( "pid.org.name", -1 );
			ADDRESS_PHYS_PID = settings.getIntValue( "pid.address.phys", -1 );
			ADDRESS_JUR_PID = settings.getIntValue( "pid.address.jur", -1 );
			INN_PID = settings.getIntValue( "pid.inn", -1 );
			KPP_PID = settings.getIntValue( "pid.kpp", -1 );
			BIK_PID = settings.getIntValue( "pid.bik", -1 );
			BANK_NAME = settings.getIntValue( "pid.bank", -1 );
			ORG_ACCOUNT_PID = settings.getIntValue( "pid.account", -1 );
			COMMENT_PID = settings.getIntValue( "pid.comment", -1 );			
			ORG_TYPE_PID = settings.getIntValue( "pid.org.type", -1 );;
			OWNER_TYPE_PID = settings.getIntValue( "pid.owner.type", -1 );;

		            
         
			
			System.out.println( " deleteting contracts.." );
			
			ConvertUtil.removeContracts( GROUP_ID, bgSetup);
			
			
			 Map<String, String> tariffMap = new HashMap<String, String>();
			 
			
			String path = args [0] + "/import";
			
			Map<String, Map<String, String> > customers =  loadCustomers( path + "/contract_phys.csv" );
			List<Map<String, String>> customerPhones =  loadPhones( path + "/tel_phys.csv", tariffMap );
			
			loadTarifs( customers, tariffMap );
			
			
			tariffMap = new HashMap<String, String>();
			Map<String, Map<String, String> > firms =  loadFirms( path + "/contract_jur.csv" );
			List<Map<String, String>> firmPhones =  loadPhones( path + "/tel_jur.csv", tariffMap );
			
			loadTarifs( firms, tariffMap );
			
			Map<String, Map<String, String> > firmOrgTypes =  loadOrgType( path + "/org_type.csv" );
			Map<String, Map<String, String> > firmOwnerTypes =  loadOwnerType( path + "/owner_type.csv" );
			
			
			ConvertUtil.combineMaps( firms, firmOrgTypes );
			ConvertUtil.combineMaps( firms, firmOwnerTypes );
			
			buildListMap();
			
			System.out.println("creating customers..");
			Map<String, Integer> customerContracts = createContracts(  customers, false );			
			createPoints( customerPhones, customerContracts );
			System.out.println("creating firms..");
			Map<String, Integer> firmContracts =  createContracts(  firms, true );			
			createPoints( firmPhones, firmContracts );
			
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
		
		System.out.println("ok");
		//-  ,  EventProcessor
		System.exit( 0 );

	}

}
