package bitel.billing.test.convert;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.Reader;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import bitel.billing.common.BaseException;
import bitel.billing.common.CommonTimeUtils;
import bitel.billing.common.CommonUtils;
import bitel.billing.common.TimeUtils;
import bitel.billing.server.admin.bean.AddressUtils;
import bitel.billing.server.admin.resource.bean.NumberResource;
import bitel.billing.server.admin.resource.bean.NumberResourceUseManager;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.contract.object.bean.AddressParamValue;
import bitel.billing.server.contract.object.bean.ContractObject;
import bitel.billing.server.contract.object.bean.ListValue;
import bitel.billing.server.contract.object.bean.ListValueManager;
import bitel.billing.server.contract.object.bean.ObjectManager;
import bitel.billing.server.contract.object.bean.ParamValueManager;
import bitel.billing.server.phone.bean.ClientItem;
import bitel.billing.server.phone.bean.ClientItemManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.DefaultServerSetup;
import bitel.billing.server.util.SetupData;
import bitel.billing.server.util.Utils;

public class Mnu 
{
	private static SetupData bgSetup = null;
	private static int GROUP_ID = 1;
	private static int PHYS_PATTERN = 2;
	private static int JUR_PATTERN = 1;
	//private static int SOURCE_ID = 1;
	private static int MODULE_ID = 1;
	private static int OBJECT_TYPE_ID = 9;
	
	private static int MD110_ID = 1;
	private static int SI2000_ID = 2;
	
	private static int OBJ_PID_PHONE = 19; 
	private static int OBJ_PID_ATS = 26;
	private static int OBJ_PID_DATE_INSTALL = 15;
	private static int OBJ_PID_CATEGORY = 11;
	private static int OBJ_PID_PORT_TYPE = 23;
	private static int OBJ_PID_ORG_TYPE = 27;
	private static int OBJ_PID_CITY = 24;
	private static int OBJ_PID_ADDRESS = 7;
	private static int OBJ_PID_SUB_DIVISION = 9;
	private static int OBJ_PID_SECTION = 10;
	private static int OBJ_PID_POST = 14;
	private static int OBJ_PID_FIO = 6;
	private static int OBJ_PID_COMMENT = 28;
	private static int OBJ_PID_ADDRESS_TEXT = 32;
	private static int OBJ_PID_PASSPORT = 8;
	
	private static Map< Integer, Map > listMap  = new HashMap< Integer, Map > (); 
	
	private static Map<String, Integer > streetMap = new  HashMap<String, Integer > ();
	private static Map<Integer, Map<String, Integer> >  houseMap = new HashMap<Integer, Map<String, Integer> >(); 
	private static Map<String, Integer >  cityMap = new HashMap<String, Integer>();
	
	private static Calendar contractDate = TimeUtils.parseCalendar ( "01.10.2008", "dd.MM.yyyy" );
	
	private static Pattern pattern = Pattern.compile( "^(.+?)(,)*?(\\s*)(\\d+)(\\S+?)*?(-(\\d+))*?$" );
	
	private static String MD110_LIST [] = { "MD110; ", "MD110; ", "MD110; -2", "MD110; " };
	
											
	private static String SI2000_LIST [] = {"MD110; ", "MD110; ", "SI-2000; ", "HiPath 3559; -",
		"DX-500; ", "Cisco; ", "BP-250; ", "BP-250; ",
		"BP-250; ", "BP-250; . "  };
	
	private static Set<String> MD110_SET = new HashSet<String>();
	private static Set<String> SI2000_SET = new HashSet<String>();
	
	
	
	static{
		
		
		for (String value : MD110_LIST)
		{
			MD110_SET.add( value );
		}
		
		for (String value : SI2000_LIST)
		{
			SI2000_SET.add( value );
		}
				
	}
	
	
	
	
	public static List< Map >  loadData( String filePath) throws IOException
	{
		List< Map > result = new ArrayList<Map>();
		Reader reader =  new java.io.InputStreamReader( new FileInputStream( filePath  ), "utf8" );
		 
		String[][] lines = com.Ostermiller.util.ExcelCSVParser.parse(  reader, ';' );
		
		for ( int i = 1 ; i < lines.length; i++)
		{
			String [] line =  lines[i];
			Map map = new HashMap();
			
			map.put( "number", line [0] );
			map.put( "firm",  line [1] );
			map.put( "ats",  line [2]  );
			map.put( "date_install",  line [3]  );
			map.put( "category",  line [4]  );
			map.put( "port_type",  line [5]  );
			map.put( "org_type",  line [6]  );			
			map.put( "city",  line [7] );
			map.put( "address",  line [8] );
			map.put( "sub_divison",  line [9] );
			map.put( "sector", line [10] );
			map.put( "post", line [11] );
			map.put( "fio", line [12] );
			map.put( "passport", line [13] );
			map.put( "comment", line [14] );
			result.add( map );			
			
		}
		
		return result;
	}
	
	
	
	private static Map < Integer, Contract> createContacts( List<Map> numbers )
	{
		
		Map < Integer, Contract> result = new HashMap<Integer, Contract>();
		Connection con = null;
		Date currDate = new Date();
		
		Map<String, Contract> contactMap = new HashMap<String, Contract>();
		
		cityMap = ConvertUtil.getBillingCityMap ( bgSetup );
		streetMap = ConvertUtil.getBillingStreetMap ( bgSetup );
		houseMap = geHouseMap( bgSetup ); 		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			ContractManager manager =  new ContractManager( con );
			
			System.out.println( numbers.size() + " numbers was found..");		
			
			int idx = 0;
			for ( Map<String, String> map : numbers)
			{				
	    		int pattern = 0;
	    		
	    		String title =map.get( "firm" );
	    		
	    		Contract contract = null;
	    		
	    		boolean createFirm = false; 
	    		boolean createFlat = false;
	    		
	    		if (CommonUtils.isEmptyString( title ))
	    		{
	    			continue;
	    		}
	    		else if (title.equals( "" ))
	    		{
	    			pattern = PHYS_PATTERN;
	    			title = map.get( "post" );
	    			createFlat = true;
	    			
	    		}
	    		else if (  ( contract = contactMap.get( title ) ) == null)
	    		{
	    			pattern = JUR_PATTERN;
	    			createFirm = true;
	    		}
	    		
	    			    		
	    		if ( createFlat || createFirm )
	    		{
	    			contract = manager.createFromPattern( pattern, null,  contractDate, "");
	    		}
	    		
	    		if (contract != null)
	    		{	
	    			int cid = contract.getID();
	    			
	    			map.put( "cid", String.valueOf( cid ) );
	    			
	    			result.put( cid, contract );	
	    			
	    			
	    			if ( createFlat || createFirm  )
	    			{	    			
						updateContactInfo( cid, map, title );
	    			}
					
					if (createFirm)
					{
						contactMap.put( title, contract );
					}
					
	    		}
	    		
	    		
	    		        		
	    	}			
			
			System.out.println( result.size() + " contracts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
		return result;		
	}	
	
	private static void updateContactInfo( int cid, Map<String, String> map, String title )
	{
		Connection con = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,  " +						
						" comment = ? " +
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, GROUP_ID );			
			ps.setString( idx++, title );
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}		
		
	}

	private static void createPoints(	List<Map> numbers )
	{
		Connection con = null;
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			
			int pc = 0;
			
			for (Map<String, String> map : numbers)
			{
				if (map.get( "cid" ) == null)
				{
					continue;
				}
				
				Integer cid = Integer.valueOf( map.get( "cid" ) );

				String number = "738259" + map.get( "number" ) ;
				String ats = map.get( "ats" );
				
				 
				
				
				
				
				pc++;
				int sourceId = 0;

				if (!CommonUtils.isEmptyString( ats ))
				{
					if ( MD110_SET.contains( ats ) )
					{
						sourceId = MD110_ID;
					}
					else if ( SI2000_SET.contains( ats ) )					 
					{
						sourceId = SI2000_ID;
					}
					else
					{
						System.out.println( " error : unknown ATS!!! for number " + number);
						System.out.println( "ats = " + ats);
						continue;						
					}

										
				}
				else
				{
					System.out.println( " error : empty ATS!!! for number " + number);
					continue;
				}
				
				ContractObject object = createObject( cid, number, contractDate, map );
				createPoint( cid, number, contractDate, sourceId, con, object );
				

				/*
				 *     //    
				 *      Map<String,
				 * NumberChange> numberMap = new HashMap<String,
				 * NumberChange>();
				 * 
				 * for( NumberChange change : numberMap.values() ) { if(
				 * change.resource == null ) { continue; }
				 * 
				 * List<NumberResourceUse> useList = man.getResourceUse(
				 * change.resource ); resourceUseManager.updateResourceUse(
				 * change.resource.getId(), useList ); }
				 */
			}
			
			System.out.println( pc + " points was added" );
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
			throw new RuntimeException("Error while creating points");
		}

		finally
		{
			bgSetup.returnConToPool( con );
		}

	}
	
	private static ContractObject createObject( Integer cid, String number, Calendar date, Map<String, String> map )
	{
		
		Connection con = null;
		ContractObject object = null;
		
		try
		{
			con = bgSetup.getDBConnectionFromPool();
			ObjectManager objectManager = new ObjectManager( con );       
			
			object = new ContractObject();
						
			object.setContractId( cid );
			object.setTypeId( OBJECT_TYPE_ID );
							
			
			object.setDate1( date );					
			object.setTitle( number );
			
			
			objectManager.updateObject( object );
			
			updateObjectParams( object.getId(), map );
			
			updateAddress( object.getId(), map, cityMap, streetMap, houseMap );
		}
		finally 
		{
			bgSetup.returnConToPool( con );
		}
		
		return object;
	}

	private static void createPoint(	Integer cid,
										String number,
										Calendar date,
										int sourceId,
										Connection con,
										ContractObject object ) throws BaseException
	{
		ClientItem item = new ClientItem();				
		item.setContractId( cid );
		item.setSourceId( sourceId );

		item.setDate1( date );

		item.setType( ClientItem.TYPE_POINT );

		item.setClientNumbers( Utils.stringToList( number ) );
		item.setClientPorts( new ArrayList<String>() );
		
		item.setComment( "   " );
		item.setAlias( "" );
		item.setObjectId( object.getId() );
		 
		ClientItemManager man = new ClientItemManager( con,
				MODULE_ID );
		NumberResourceUseManager resourceUseManager = new NumberResourceUseManager( con,
				MODULE_ID );

		man.addClientItem( item );		
	}

	
	private static void updateObjectParams(	int objectId, Map<String, String> map)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();			
			
			
							
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "number" ), OBJ_PID_PHONE );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "category" ), OBJ_PID_CATEGORY );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "sub_divison" ), OBJ_PID_SUB_DIVISION );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "sector" ), OBJ_PID_SECTION );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "post" ), OBJ_PID_POST );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "fio" ), OBJ_PID_FIO );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "comment" ), OBJ_PID_COMMENT );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "address" ), OBJ_PID_ADDRESS_TEXT );
			ConvertUtil.addObjectParamString ( objectId, con, map.get( "passport" ), OBJ_PID_PASSPORT );
			
			updateObjectListParam( objectId, con, map.get( "ats" ),  OBJ_PID_ATS );
			updateObjectListParam( objectId, con, map.get( "port_type" ),  OBJ_PID_PORT_TYPE );
			updateObjectListParam( objectId, con, map.get( "org_type" ),  OBJ_PID_ORG_TYPE );
			updateObjectListParam( objectId, con, map.get( "city" ),  OBJ_PID_CITY );
			
			
			String dateStr = map.get( "date_install" );
			if ( !CommonUtils.isEmptyString( dateStr ) )
			{
				Calendar date = TimeUtils.parseCalendar ( dateStr, "dd.MM.yyyy" );
				if ( date != null)
				{
					ConvertUtil.addObjectParamDate( objectId, con, date, OBJ_PID_DATE_INSTALL );
				}
			}
			
			
			
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}	
	}
	
	private static  void updateObjectListParam(int objectId, Connection con, String value, int pid   )
	{
		
		if ( CommonUtils.isEmptyString( value ) || CommonUtils.isBlankString( ( value ) ) )
		{
			return;
		}
		
		Map map = listMap.get( pid ); 
		if ( map == null)
		{
			map = new HashMap();
			listMap.put ( pid, map);
		}
		
		ListValue listValue = (ListValue) map.get( value );
		if ( listValue == null)
		{
			listValue = new ListValue();
			listValue.setTitle( value );
			listValue.setParamId( pid );
			map.put( value, listValue );
			
		}
		ListValueManager manager = new ListValueManager( con );
		manager.updateValue( listValue );
		
		
		ConvertUtil.addObjectParamList( objectId, con, listValue.getId(), pid );
		
	}
	private static void buildListMap ()
	{
		
		/*
		updateObjectListParam( objectId, con, map.get( "ats" ),  OBJ_PID_ATS );
		updateObjectListParam( objectId, con, map.get( "port_type" ),  OBJ_PID_PORT_TYPE );
		updateObjectListParam( objectId, con, map.get( "org_type" ),  OBJ_PID_ORG_TYPE );
		updateObjectListParam( objectId, con, map.get( "city" ),  OBJ_PID_CITY );
		*/
		
		listMap.put( OBJ_PID_ATS, buildListMap ( OBJ_PID_ATS ) );			
		listMap.put( OBJ_PID_PORT_TYPE, buildListMap ( OBJ_PID_PORT_TYPE ) );
		listMap.put( OBJ_PID_ORG_TYPE, buildListMap ( OBJ_PID_ORG_TYPE ) );
		listMap.put( OBJ_PID_CITY, buildListMap ( OBJ_PID_CITY ) );
	}
	
	private static Map buildListMap ( int pid )
	{
		
		Map result = new HashMap ();
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			ListValueManager manager = new ListValueManager( con );
			
			
			List<ListValue>  values = manager.getValues( pid );
			for ( ListValue value : values)
			{
				result.put( value.getTitle(), value );
			}
		}
		catch( Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			bgSetup.returnConToPool( con );
		}
		
		return result;
	}
	
	private static void updateAddress(	int objectId,										
	                                 	Map<String, String> map,
	                                 	Map<String, Integer > cityMap,
	                                 	Map<String, Integer > streetMap,	                                 	
	                                 	Map<Integer, Map<String, Integer> >  houseMap)
	{
		
		
		Connection con = null;
		try
		{

			con = bgSetup.getDBConnectionFromPool();
			
			String address = map.get( "address" );
			String number = map.get( "number" );
			address = address.trim();
			
			if ( CommonUtils.isEmptyString(  address ) || address.equals( ", -" ))
			{
				return;
			}
			
			//-, 267-51
		
			String city = map.get( "city" );
			String street = "";
			String house = "";
			String flat = "";
			String frac = "";
			//String comment ="";
			
						
			
			Matcher m = null;
		
			//"^(.+)(,)*?(\\s*)(\\d+)([^\\d\\s]\\S*)(-(\\d+))*?$"
			
			if( (m = pattern.matcher( address )).find() )
			{
				street =   m.group( 1 );
				house = m.group( 4 );
				frac = m.group( 5 );
				flat = m.group( 7 );
			}
			else  
			{
				
				System.out.println( " Unknown address format(" + number +"):"  + address); 		
				return;
			}
			
			if ( flat == null)
			{
				flat = "";
			}
			if ( frac == null)
			{
				frac = "";
			}
			if (CommonUtils.isEmptyString( street ) ||  CommonUtils.isEmptyString( house ) )
			{
				System.out.println( " Unknown address format(" + number +"):"  + address);
				return;
			}
			
			if ( !CommonUtils.isEmptyString( flat ) && flat.length() > 10 )
			{
				System.out.println( " flat length > 10 (" + number +"):"  + address);
				return;
			}
			
			
			Integer cityId = -1;
			if ( city != null)
			{
				cityId = cityMap.get( city );
				if ( cityId == null)
				{			
					String query = "INSERT into address_city(title) VALUES(?) ";
					PreparedStatement ps =  con.prepareStatement(   query );
					ps.setString( 1, city );								
					ps.executeUpdate();
					cityId = ConvertUtil.lastInsertId( con );
					cityMap.put( city, cityId );
				}				
			}					
			
			Integer streetId = streetMap.get( street );
			
			if ( streetId == null)
			{			
				String query = "INSERT into address_street(title, cityId) VALUES(?, ?) ";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setString( 1, street );								
				ps.setInt( 2, cityId );
				ps.executeUpdate();
				streetId = ConvertUtil.lastInsertId( con );
				streetMap.put( street, streetId );
			}
			
		
			
			Map<String, Integer> houses = houseMap.get( streetId ); 
			if ( houses == null )
			{
				houses = new HashMap<String, Integer>();
				
				houseMap.put( streetId, houses );
			}
			String key =  getHouseKey( Integer.valueOf( house), frac );
			if ( houses.get( key ) == null )
			{
				
				String query = "INSERT INTO address_house " + "( cityid,  areaid, quarterid, streetid,"
				   + " house, frac, box_index, amount, comment, dt) " + "VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				PreparedStatement ps =  con.prepareStatement(   query );
				ps.setInt( 1, cityId );
				ps.setInt( 2, 0 );
				ps.setInt( 3, 0 );
				ps.setInt( 4, streetId );
				ps.setInt( 5, Integer.valueOf( house) );
				ps.setString( 6, frac );
				ps.setString( 7, "" );
				ps.setInt( 8, 0 );
				ps.setString( 9, "" );
				ps.setDate( 10, TimeUtils.convertDateToSQL( new  Date() ) );
				ps.executeUpdate();		
				int houseId = ConvertUtil.lastInsertId( con );
				houses.put( key, houseId );
			}
			
			int houseId =  houses.get( key );
			
			
			
			
			String addressFull = AddressUtils.getAddress( bgSetup, "", city, "", "", street, house, frac, flat, "", "", "", ""  ); 
			
		  	AddressParamValue paramValue = new AddressParamValue();
	        paramValue.setObjectId( objectId );
	        paramValue.setParamId( OBJ_PID_ADDRESS );
	        paramValue.setHouseId( houseId );
	        paramValue.setFlat( flat );
	        paramValue.setPod( -1 );
	        paramValue.setRoom( "" );
	        paramValue.setFloor( -1 );
	        paramValue.setComment( "" );
	        paramValue.setAddress( addressFull );

	        new ParamValueManager( con ).updateParamValue( paramValue );  
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			bgSetup.returnConToPool( con );
		}				
		
	}	
	private static String getHouseKey( int house, String frac )
	{
		String result  = String.valueOf( house );
		
		if ( !CommonUtils.isEmptyString( frac ))
		{
			result += "##" + frac;
		}
		
		return result;
	}		
			
	public  static Map<Integer, Map<String, Integer> >  geHouseMap( DefaultServerSetup setup )
	{
		Map<Integer, Map<String, Integer> > result = new HashMap<Integer, Map<String, Integer> >();
		Connection con = null;
		try
		{
			con = setup.getDBConnectionFromPool();
			
			String query = "SELECT streetid, house, id, frac FROM address_house";
			
			
			PreparedStatement ps =  con.prepareStatement(   query );            
			ResultSet rs = ps.executeQuery();
			while ( rs.next() )
			{
				int steetId = rs.getInt( 1 );
				int house = rs.getInt( 2 );
				int houseId = rs.getInt( 3 );
				String frac = rs.getString( 4 );
				
				
				Map<String,Integer> houses = result.get( steetId );
				if ( houses == null)
				{
					houses = new HashMap<String, Integer>();
					result.put( steetId, houses );
				}
				houses.put ( getHouseKey( house, frac ) , houseId );
				
			}
			rs.close();
		} catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			setup.returnConToPool( con );
		}
		
		
		return result; 
	}	
	public static void main( String[] args )
	{
		try
		{
		
			bgSetup = new SetupData("data.data");
			
			EventProcessor.initProcessor( bgSetup, false );
			
			System.out.println( " deleteting contracts.." );
			
			ConvertUtil.removeContracts( GROUP_ID, bgSetup);	
			
			
			List< Map > numbers =  loadData( args [0] );
			
			buildListMap();
			
			Map < Integer, Contract> contracts = createContacts(  numbers );
			createPoints( numbers ); 
			
			
			
			System.out.println("ok");
			
		} catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
        
	}
	
	
	
}


